git-stash.shon commit Merge branch 'jc/apply-blank-at-eof-fix' into maint (e63f87a)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  11                       [-u|--include-untracked] [-a|--all] [<message>]]
  12   or: $dashless clear"
  13
  14SUBDIRECTORY_OK=Yes
  15OPTIONS_SPEC=
  16START_DIR=`pwd`
  17. git-sh-setup
  18. git-sh-i18n
  19require_work_tree
  20cd_to_toplevel
  21
  22TMP="$GIT_DIR/.git-stash.$$"
  23TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
  24trap 'rm -f "$TMP-"* "$TMPindex"' 0
  25
  26ref_stash=refs/stash
  27
  28if git config --get-colorbool color.interactive; then
  29       help_color="$(git config --get-color color.interactive.help 'red bold')"
  30       reset_color="$(git config --get-color '' reset)"
  31else
  32       help_color=
  33       reset_color=
  34fi
  35
  36no_changes () {
  37        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  38        git diff-files --quiet --ignore-submodules &&
  39        (test -z "$untracked" || test -z "$(untracked_files)")
  40}
  41
  42untracked_files () {
  43        excl_opt=--exclude-standard
  44        test "$untracked" = "all" && excl_opt=
  45        git ls-files -o -z $excl_opt
  46}
  47
  48clear_stash () {
  49        if test $# != 0
  50        then
  51                die "$(gettext "git stash clear with parameters is unimplemented")"
  52        fi
  53        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  54        then
  55                git update-ref -d $ref_stash $current
  56        fi
  57}
  58
  59create_stash () {
  60        stash_msg="$1"
  61        untracked="$2"
  62
  63        git update-index -q --refresh
  64        if no_changes
  65        then
  66                exit 0
  67        fi
  68
  69        # state of the base commit
  70        if b_commit=$(git rev-parse --verify HEAD)
  71        then
  72                head=$(git rev-list --oneline -n 1 HEAD --)
  73        else
  74                die "$(gettext "You do not have the initial commit yet")"
  75        fi
  76
  77        if branch=$(git symbolic-ref -q HEAD)
  78        then
  79                branch=${branch#refs/heads/}
  80        else
  81                branch='(no branch)'
  82        fi
  83        msg=$(printf '%s: %s' "$branch" "$head")
  84
  85        # state of the index
  86        i_tree=$(git write-tree) &&
  87        i_commit=$(printf 'index on %s\n' "$msg" |
  88                git commit-tree $i_tree -p $b_commit) ||
  89                die "$(gettext "Cannot save the current index state")"
  90
  91        if test -n "$untracked"
  92        then
  93                # Untracked files are stored by themselves in a parentless commit, for
  94                # ease of unpacking later.
  95                u_commit=$(
  96                        untracked_files | (
  97                                export GIT_INDEX_FILE="$TMPindex"
  98                                rm -f "$TMPindex" &&
  99                                git update-index -z --add --remove --stdin &&
 100                                u_tree=$(git write-tree) &&
 101                                printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
 102                                rm -f "$TMPindex"
 103                ) ) || die "Cannot save the untracked files"
 104
 105                untracked_commit_option="-p $u_commit";
 106        else
 107                untracked_commit_option=
 108        fi
 109
 110        if test -z "$patch_mode"
 111        then
 112
 113                # state of the working tree
 114                w_tree=$( (
 115                        git read-tree --index-output="$TMPindex" -m $i_tree &&
 116                        GIT_INDEX_FILE="$TMPindex" &&
 117                        export GIT_INDEX_FILE &&
 118                        git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
 119                        git write-tree &&
 120                        rm -f "$TMPindex"
 121                ) ) ||
 122                        die "$(gettext "Cannot save the current worktree state")"
 123
 124        else
 125
 126                rm -f "$TMP-index" &&
 127                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
 128
 129                # find out what the user wants
 130                GIT_INDEX_FILE="$TMP-index" \
 131                        git add--interactive --patch=stash -- &&
 132
 133                # state of the working tree
 134                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 135                die "$(gettext "Cannot save the current worktree state")"
 136
 137                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 138                test -s "$TMP-patch" ||
 139                die "$(gettext "No changes selected")"
 140
 141                rm -f "$TMP-index" ||
 142                die "$(gettext "Cannot remove temporary index (can't happen)")"
 143
 144        fi
 145
 146        # create the stash
 147        if test -z "$stash_msg"
 148        then
 149                stash_msg=$(printf 'WIP on %s' "$msg")
 150        else
 151                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 152        fi
 153        w_commit=$(printf '%s\n' "$stash_msg" |
 154        git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
 155        die "$(gettext "Cannot record working tree state")"
 156}
 157
 158save_stash () {
 159        keep_index=
 160        patch_mode=
 161        untracked=
 162        while test $# != 0
 163        do
 164                case "$1" in
 165                -k|--keep-index)
 166                        keep_index=t
 167                        ;;
 168                --no-keep-index)
 169                        keep_index=n
 170                        ;;
 171                -p|--patch)
 172                        patch_mode=t
 173                        # only default to keep if we don't already have an override
 174                        test -z "$keep_index" && keep_index=t
 175                        ;;
 176                -q|--quiet)
 177                        GIT_QUIET=t
 178                        ;;
 179                -u|--include-untracked)
 180                        untracked=untracked
 181                        ;;
 182                -a|--all)
 183                        untracked=all
 184                        ;;
 185                --)
 186                        shift
 187                        break
 188                        ;;
 189                -*)
 190                        option="$1"
 191                        # TRANSLATORS: $option is an invalid option, like
 192                        # `--blah-blah'. The 7 spaces at the beginning of the
 193                        # second line correspond to "error: ". So you should line
 194                        # up the second line with however many characters the
 195                        # translation of "error: " takes in your language. E.g. in
 196                        # English this is:
 197                        #
 198                        #    $ git stash save --blah-blah 2>&1 | head -n 2
 199                        #    error: unknown option for 'stash save': --blah-blah
 200                        #           To provide a message, use git stash save -- '--blah-blah'
 201                        eval_gettextln "$("error: unknown option for 'stash save': \$option
 202       To provide a message, use git stash save -- '\$option'")"
 203                        usage
 204                        ;;
 205                *)
 206                        break
 207                        ;;
 208                esac
 209                shift
 210        done
 211
 212        if test -n "$patch_mode" && test -n "$untracked"
 213        then
 214            die "Can't use --patch and ---include-untracked or --all at the same time"
 215        fi
 216
 217        stash_msg="$*"
 218
 219        git update-index -q --refresh
 220        if no_changes
 221        then
 222                say "$(gettext "No local changes to save")"
 223                exit 0
 224        fi
 225        test -f "$GIT_DIR/logs/$ref_stash" ||
 226                clear_stash || die "$(gettext "Cannot initialize stash")"
 227
 228        create_stash "$stash_msg" $untracked
 229
 230        # Make sure the reflog for stash is kept.
 231        : >>"$GIT_DIR/logs/$ref_stash"
 232
 233        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 234                die "$(gettext "Cannot save the current status")"
 235        say Saved working directory and index state "$stash_msg"
 236
 237        if test -z "$patch_mode"
 238        then
 239                git reset --hard ${GIT_QUIET:+-q}
 240                test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
 241                if test -n "$untracked"
 242                then
 243                        git clean --force --quiet $CLEAN_X_OPTION
 244                fi
 245
 246                if test "$keep_index" = "t" && test -n $i_tree
 247                then
 248                        git read-tree --reset -u $i_tree
 249                fi
 250        else
 251                git apply -R < "$TMP-patch" ||
 252                die "$(gettext "Cannot remove worktree changes")"
 253
 254                if test "$keep_index" != "t"
 255                then
 256                        git reset
 257                fi
 258        fi
 259}
 260
 261have_stash () {
 262        git rev-parse --verify $ref_stash >/dev/null 2>&1
 263}
 264
 265list_stash () {
 266        have_stash || return 0
 267        git log --format="%gd: %gs" -g "$@" $ref_stash --
 268}
 269
 270show_stash () {
 271        assert_stash_like "$@"
 272
 273        git diff ${FLAGS:---stat} $b_commit $w_commit
 274}
 275
 276#
 277# Parses the remaining options looking for flags and
 278# at most one revision defaulting to ${ref_stash}@{0}
 279# if none found.
 280#
 281# Derives related tree and commit objects from the
 282# revision, if one is found.
 283#
 284# stash records the work tree, and is a merge between the
 285# base commit (first parent) and the index tree (second parent).
 286#
 287#   REV is set to the symbolic version of the specified stash-like commit
 288#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 289#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 290#   s is set to the SHA1 of the stash commit
 291#   w_commit is set to the commit containing the working tree
 292#   b_commit is set to the base commit
 293#   i_commit is set to the commit containing the index tree
 294#   u_commit is set to the commit containing the untracked files tree
 295#   w_tree is set to the working tree
 296#   b_tree is set to the base tree
 297#   i_tree is set to the index tree
 298#   u_tree is set to the untracked files tree
 299#
 300#   GIT_QUIET is set to t if -q is specified
 301#   INDEX_OPTION is set to --index if --index is specified.
 302#   FLAGS is set to the remaining flags
 303#
 304# dies if:
 305#   * too many revisions specified
 306#   * no revision is specified and there is no stash stack
 307#   * a revision is specified which cannot be resolve to a SHA1
 308#   * a non-existent stash reference is specified
 309#
 310
 311parse_flags_and_rev()
 312{
 313        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 314        PARSE_CACHE="$*"
 315
 316        IS_STASH_LIKE=
 317        IS_STASH_REF=
 318        INDEX_OPTION=
 319        s=
 320        w_commit=
 321        b_commit=
 322        i_commit=
 323        u_commit=
 324        w_tree=
 325        b_tree=
 326        i_tree=
 327        u_tree=
 328
 329        REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
 330
 331        FLAGS=
 332        for opt
 333        do
 334                case "$opt" in
 335                        -q|--quiet)
 336                                GIT_QUIET=-t
 337                        ;;
 338                        --index)
 339                                INDEX_OPTION=--index
 340                        ;;
 341                        -*)
 342                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 343                        ;;
 344                esac
 345        done
 346
 347        set -- $REV
 348
 349        case $# in
 350                0)
 351                        have_stash || die "$(gettext "No stash found.")"
 352                        set -- ${ref_stash}@{0}
 353                ;;
 354                1)
 355                        :
 356                ;;
 357                *)
 358                        die "$(eval_gettext "Too many revisions specified: \$REV")"
 359                ;;
 360        esac
 361
 362        REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || {
 363                reference="$1"
 364                die "$(eval_gettext "\$reference is not valid reference")"
 365        }
 366
 367        i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
 368        set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
 369        s=$1 &&
 370        w_commit=$1 &&
 371        b_commit=$2 &&
 372        w_tree=$3 &&
 373        b_tree=$4 &&
 374        i_tree=$5 &&
 375        IS_STASH_LIKE=t &&
 376        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 377        IS_STASH_REF=t
 378
 379        u_commit=$(git rev-parse --quiet --verify $REV^3 2>/dev/null) &&
 380        u_tree=$(git rev-parse $REV^3: 2>/dev/null)
 381}
 382
 383is_stash_like()
 384{
 385        parse_flags_and_rev "$@"
 386        test -n "$IS_STASH_LIKE"
 387}
 388
 389assert_stash_like() {
 390        is_stash_like "$@" || {
 391                args="$*"
 392                die "$(eval_gettext "'\$args' is not a stash-like commit")"
 393        }
 394}
 395
 396is_stash_ref() {
 397        is_stash_like "$@" && test -n "$IS_STASH_REF"
 398}
 399
 400assert_stash_ref() {
 401        is_stash_ref "$@" || {
 402                args="$*"
 403                die "$(eval_gettext "'\$args' is not a stash reference")"
 404        }
 405}
 406
 407apply_stash () {
 408
 409        assert_stash_like "$@"
 410
 411        git update-index -q --refresh || die "$(gettext "unable to refresh index")"
 412
 413        # current index state
 414        c_tree=$(git write-tree) ||
 415                die "$(gettext "Cannot apply a stash in the middle of a merge")"
 416
 417        unstashed_index_tree=
 418        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 419                        test "$c_tree" != "$i_tree"
 420        then
 421                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 422                test $? -ne 0 &&
 423                        die "$(gettext "Conflicts in index. Try without --index.")"
 424                unstashed_index_tree=$(git write-tree) ||
 425                        die "$(gettext "Could not save index tree")"
 426                git reset
 427        fi
 428
 429        if test -n "$u_tree"
 430        then
 431                GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
 432                GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
 433                rm -f "$TMPindex" ||
 434                die 'Could not restore untracked files from stash'
 435        fi
 436
 437        eval "
 438                GITHEAD_$w_tree='Stashed changes' &&
 439                GITHEAD_$c_tree='Updated upstream' &&
 440                GITHEAD_$b_tree='Version stash was based on' &&
 441                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 442        "
 443
 444        if test -n "$GIT_QUIET"
 445        then
 446                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 447        fi
 448        if git merge-recursive $b_tree -- $c_tree $w_tree
 449        then
 450                # No conflict
 451                if test -n "$unstashed_index_tree"
 452                then
 453                        git read-tree "$unstashed_index_tree"
 454                else
 455                        a="$TMP-added" &&
 456                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 457                        git read-tree --reset $c_tree &&
 458                        git update-index --add --stdin <"$a" ||
 459                                die "$(gettext "Cannot unstage modified files")"
 460                        rm -f "$a"
 461                fi
 462                squelch=
 463                if test -n "$GIT_QUIET"
 464                then
 465                        squelch='>/dev/null 2>&1'
 466                fi
 467                (cd "$START_DIR" && eval "git status $squelch") || :
 468        else
 469                # Merge conflict; keep the exit status from merge-recursive
 470                status=$?
 471                if test -n "$INDEX_OPTION"
 472                then
 473                        gettextln "Index was not unstashed." >&2
 474                fi
 475                exit $status
 476        fi
 477}
 478
 479pop_stash() {
 480        assert_stash_ref "$@"
 481
 482        apply_stash "$@" &&
 483        drop_stash "$@"
 484}
 485
 486drop_stash () {
 487        assert_stash_ref "$@"
 488
 489        git reflog delete --updateref --rewrite "${REV}" &&
 490                say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
 491                die "$(eval_gettext "\${REV}: Could not drop stash entry")"
 492
 493        # clear_stash if we just dropped the last stash entry
 494        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 495}
 496
 497apply_to_branch () {
 498        test -n "$1" || die "$(gettext "No branch name specified")"
 499        branch=$1
 500        shift 1
 501
 502        set -- --index "$@"
 503        assert_stash_like "$@"
 504
 505        git checkout -b $branch $REV^ &&
 506        apply_stash "$@" && {
 507                test -z "$IS_STASH_REF" || drop_stash "$@"
 508        }
 509}
 510
 511PARSE_CACHE='--not-parsed'
 512# The default command is "save" if nothing but options are given
 513seen_non_option=
 514for opt
 515do
 516        case "$opt" in
 517        -*) ;;
 518        *) seen_non_option=t; break ;;
 519        esac
 520done
 521
 522test -n "$seen_non_option" || set "save" "$@"
 523
 524# Main command set
 525case "$1" in
 526list)
 527        shift
 528        list_stash "$@"
 529        ;;
 530show)
 531        shift
 532        show_stash "$@"
 533        ;;
 534save)
 535        shift
 536        save_stash "$@"
 537        ;;
 538apply)
 539        shift
 540        apply_stash "$@"
 541        ;;
 542clear)
 543        shift
 544        clear_stash "$@"
 545        ;;
 546create)
 547        if test $# -gt 0 && test "$1" = create
 548        then
 549                shift
 550        fi
 551        create_stash "$*" && echo "$w_commit"
 552        ;;
 553drop)
 554        shift
 555        drop_stash "$@"
 556        ;;
 557pop)
 558        shift
 559        pop_stash "$@"
 560        ;;
 561branch)
 562        shift
 563        apply_to_branch "$@"
 564        ;;
 565*)
 566        case $# in
 567        0)
 568                save_stash &&
 569                say "$(gettext "(To restore them type \"git stash apply\")")"
 570                ;;
 571        *)
 572                usage
 573        esac
 574        ;;
 575esac